-- Loadable reg

LIBRARY ieee;
USE ieee.std_logic_1164.all;
LIBRARY work;
USE work.defines.all;


ENTITY reg IS

	PORT
	(
		D		: IN	STD_LOGIC_VECTOR(wordsize-1 downto 0);
		clock	: IN	STD_LOGIC;
		load	: IN	STD_LOGIC;
		Q		: OUT 	STD_LOGIC_VECTOR(wordsize-1 downto 0)
	);
	
END reg;

ARCHITECTURE a OF reg IS
	SIGNAL	QSignal	: STD_LOGIC_VECTOR(wordsize-1 downto 0);
BEGIN
	PROCESS (clock)
	BEGIN
		IF (clock'EVENT AND clock = '1') THEN
			IF load = '1' THEN 
				QSignal <= D;
			ELSE
				QSignal <= QSignal;
			END IF;
		END IF;
	END PROCESS;
	Q <= QSignal;
END a;

