
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_signed.all;

ENTITY alu IS
	PORT (op1, op2		: IN  std_logic_vector(7 downto 0);
          alu_fn        : IN  std_logic_vector(3 downto 0);
		   result		: OUT std_logic_vector(7 downto 0));
END alu;

ARCHITECTURE a OF alu IS
BEGIN
PROCESS(alu_fn)
 BEGIN
  CASE alu_fn IS
    WHEN "0000" => result <= op1 ; 
    WHEN "0001" => result <= op2 ;
    WHEN "0010" => result <= not op1 ;
    WHEN "0011" => result <= not op2 ;

    WHEN "0100" => result <= op1 and op2;
    WHEN "0101" => result <= op1 or  op2;
    WHEN "0110" => result <= op1 xor op2;

    WHEN "0111" => result <= op1 + "00000001";
    WHEN "1000" => result <= op1 + op2 ;
    WHEN "1001" => result <= op1 + op2 + "00000001";

    WHEN "1010" => result <= op1 - op2;
    WHEN "1011" => result <= op2 - op1 ;
    WHEN OTHERS => result <= op1; 
  END CASE;
 END PROCESS;
END a;



